import pygame, math
from pygame import gfxdraw
from thorpy._utils.colorscomputing import linear_combination, scale_color, normalize_color
from thorpy import Grid

import thorpy.painting.painters.roundrect as roundrect
##from thorpy.painting.graphics import get_aa_ellipsis

def _get_round_help(d1, d2, color, a0, light, dark): #solution chosen doesnt use pixarray because of numpy dependance
    r1 = d1 // 2
    r2 = d2 // 2
    surface = pygame.Surface((d1,)*2, pygame.SRCALPHA).convert_alpha()
    gfxdraw.filled_circle(surface, r1, r1, r2+1, color)
    for x in range(d1):
        for y in range(d1):
            d = math.hypot(x-r1, y-r1)
            if r2 < d < r1:
                angle = math.atan2(x-r1,y-r1) + a0
                k = abs(math.sin(angle/2))
                c = linear_combination(light, dark, k)
                gfxdraw.pixel(surface, x, y, c)
    return surface

##def _get_round_help(d1, d2, color, a0, light, dark): #solution chosen doesnt use pixarray because of numpy dependance
##    r1 = d1 // 2
##    r2 = d2 // 2
##    surface = pygame.Surface((d1,)*2, pygame.SRCALPHA).convert_alpha()
####        gfxdraw.filled_circle(surface, r1, r1, r2+1, color)
##    for x in range(d1):
##        for y in range(d1):
##            d = math.hypot(x-r1, y-r1)
##            if r2 < d < r1:
##                angle = math.atan2(x-r1,y-r1) + a0
##                k = abs(math.sin(angle/2))
##                c = linear_combination(light, dark, k)
##                gfxdraw.pixel(surface, x, y, c)
##    e = get_aa_ellipsis((2*(r2+1), 2*(r2+1)), color)
##    r = e.get_rect();r.center = surface.get_rect().center
##    surface.blit(e, r)
##    return surface

def get_round(d1, thick, color, a0=3.14/4., lightness=0.3, light=None, dark=None):
    if not light:
        light = normalize_color(scale_color(1. + lightness,color))
        dark = normalize_color(scale_color(1. - lightness,color))
##    d2 = int(200*(1. - thick))
##    s = _get_round_help(200, d2, color, a0, light, dark)
##    return pygame.transform.scale(s, (d1, d1))
##    return _get_round_help(d1, int(d1*(1.-thick)), color, a0, light, dark)
    d1_old = d1
    d1 *= 5
    s = _get_round_help(d1, int(d1*(1.-thick)), color, a0, light, dark)
    return pygame.transform.smoothscale(s, (d1_old,d1_old))

def get_grid(nx, ny, d, gap, color, bckgr):
    light = normalize_color(scale_color(1. + 0.2,color))
    dark = normalize_color(scale_color(1. - 0.2,color))
    r = get_round(d, 0.1, bckgr, light=light, dark=dark)
    rr = r.get_rect()
    grid = Grid(nx, ny, cell_size=(d+gap,d+gap))
    painter = roundrect.RoundRect(grid.frame.size, color, radius=d//4)
    s = painter.draw()
    for rect in grid.iterrects():
        rr.center = rect.center
        s.blit(r, rr.topleft)
    return s